/*
 *  $Id: attr_getkey.c,v 1.4 1993/11/12 12:00:48 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Attr_create_key - generates a new attribute key

@*/
int MPI_Attr_create_key ( copy_fn, delete_fn, keyval, extra_state )
int (*copy_fn)();
int (*delete_fn)();
int *keyval;
void *extra_state;
{
  MPIR_Attr_key *new_key = NEW(MPIR_Attr_key);
  (*keyval)              = (int)new_key;
  new_key->copy_fn       = copy_fn;
  new_key->delete_fn     = delete_fn;
  new_key->ref_count     = 1;
  new_key->extra_state   = extra_state;
  return (MPI_SUCCESS);
}

